import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ActivityPanel extends JPanel {
    static final int delayMillis = 40;

    Postal p;
    Dimension dim;
    Situation sit;
    Thread t;
    boolean going_right;

    // Image image;
    // Dimension minSize;
    // Dimension preferredSize;
    // Rectangle r;

    public ActivityPanel(Postal worker) {
	String thing;

	this.going_right = true;
	this.p = worker;
	this.dim = new Dimension(400, 400);
	this.sit = new Situation(0.4);
	thing = Parser.phaseOne(p.message);
	Parser.parse(thing, this.sit);
	start();
	// this.image = (new ImageIcon("funny.gif")).getImage();
	// this.r = new Rectangle(0, 0, 0, 0);
	// this.minSize = new Dimension(600, 400);
	// this.setMinimumSize(dim);
	// this.setPreferredSize(dim);
	// this.preferredSize = new Dimension(600,400);
    }

    /*
      public Dimension getPreferredSize() {
        return preferredSize;
      }
    */

    /*
    public int getWidth() {
	return 500;
    }

    public int getHeight() {
	return 500;
    }
    */

    public Dimension getPreferredSize() {
	return this.dim;
    }

    public Dimension getMinimumSize() {
	return this.dim;
    }

    public void start() {
	stop();
	t = new Thread() { public void run() { animate(); }};
	System.out.println("Got executed!");
	t.start();
    }

    public void stop() {
	if (t != null) {
	    t.interrupt();
	    t = null;
	}
    }

    private void animate() {
	try {
	    while (!Thread.interrupted()) {
		if (this.p.pl.shouldAnimate) {
		    if (this.sit.burglar.offset[0] >= 350) {
			going_right = false;
		    } else if (this.sit.burglar.offset[0] < 10) {
			going_right = true;
		    }

		    if (going_right) {
			this.sit.burglar.offset[0]++;
		    } else {
			this.sit.burglar.offset[0]--;
		    }
		}
		/*
		  // step
		  x += vx;
		  y += vy;
		  // Make the ball wrap around the screen.
		  Dimension size = getSize();
		  if (x > size.width) x = 0;
		  if (y > size.height) y = 0;
		  if (x < 0) x = size.width;
		  if (y < 0) y = size.height;
		*/
		repaint();
		Thread.sleep(delayMillis);
	    }
	} catch (InterruptedException e) {}
    }

    public void paintComponent(Graphics g) {
	int i, j;
	int [][][] the_cord;
	int [] font_cord;
        super.paintComponent(g);  //paint background

        // g.drawImage(image, 0, 0, this);

	Rectangle q = this.getBounds();
	/*
	  if ((q.width != r.width) || (q.height != r.height)) {
	    r = q;
	  }
	*/
	g.setColor(Color.white);
	g.fillRect(0, 0, q.width, q.height);

	for (j = 1; j <= this.sit.numberPostOffices; j++) {
	    g.setColor(this.sit.postofices[j].getColor());
	    the_cord = this.sit.postofices[j].getPostOfficeCoordinates(q.width, q.height);
	    for (i = 0; i < the_cord.length; i++) {
		g.fillPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	    }

	    g.setColor(Color.black);
	    for (i = 0; i < the_cord.length; i++) {
		g.drawPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	    }

	    g.setColor(Color.black);
	    font_cord = this.sit.postofices[j].getFontCoordinates(q.width, q.height);
	    g.drawString(this.sit.postofices[j].message, font_cord[0], font_cord[1]);
	}

	for (j = 1; j <= this.sit.numberPeople; j++) {
	    g.setColor(this.sit.persons[j].h.getColor());
	    the_cord = this.sit.persons[j].h.getHouseCoordinates(q.width, q.height);
	    for (i = 0; i < the_cord.length; i++) {
		g.fillPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	    }

	    g.setColor(Color.black);
	    for (i = 0; i < the_cord.length; i++) {
		g.drawPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	    }

	    g.setColor(Color.black);
	    font_cord = this.sit.persons[j].h.getFontCoordinates(q.width, q.height);
	    g.drawString(this.sit.persons[j].h.message, font_cord[0], font_cord[1]);
	}

	g.setColor(this.sit.burglar.h.getColor());
	the_cord = this.sit.burglar.h.getHouseCoordinates(q.width, q.height);
	for (i = 0; i < the_cord.length; i++) {
	    g.fillPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	}

	g.setColor(Color.black);
	for (i = 0; i < the_cord.length; i++) {
	    g.drawPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	}

	g.setColor(Color.black);
	font_cord = this.sit.burglar.h.getFontCoordinates(q.width, q.height);
	g.drawString(this.sit.burglar.h.message, font_cord[0], font_cord[1]);

	g.drawString("Day = 0", 5, 10);
	g.drawString("Info exchanged = 0%", 275, 10);
	g.drawString("Spy visits = 0 / 3", 5, 395);
	g.drawString("Spy info = 0.1 / 0.5", 275, 395);

	for (j = 1; j <= this.sit.numberPeople; j++) {
	    g.setColor(this.sit.persons[j].getColor());
	    the_cord = this.sit.persons[j].getPersonCoordinates(q.width, q.height);
	    for (i = 0; i < the_cord.length; i++) {
		g.fillPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	    }
	}

	g.setColor(this.sit.burglar.getColor());

	the_cord = this.sit.burglar.getSpyCoordinates(q.width, q.height);
	for (i = 0; i < the_cord.length; i++) {
	    g.fillPolygon(the_cord[i][0], the_cord[i][1], the_cord[i][0].length);
	}
    }

}
